import java.math.BigInteger

def factorialRecursive(number : BigInteger) : BigInteger = {
  if (number == BigInteger.ONE)
    BigInteger.ONE
  else
    number multiply factorialRecursive(number subtract BigInteger.ONE)
}

println(factorialRecursive(new BigInteger("5")))

try {
  factorialRecursive(new BigInteger("50000"))
} catch {
  case ex => println(ex)
}

println("Tail call optimized version...")

def factorialRecursive2(number : BigInteger) = {
  def factorialRecursiveTCO(fact : BigInteger, number : BigInteger) : BigInteger = {
    if (number == BigInteger.ONE)
      fact
    else
      factorialRecursiveTCO(fact multiply number, number subtract BigInteger.ONE)
  }

  factorialRecursiveTCO(BigInteger.ONE, number)  
}

println(factorialRecursive2(new BigInteger("5")))

try {
  factorialRecursive2(new BigInteger("50000"))
  println("no worries")
} catch {
  case ex => println(ex)
}

